#include "../include/teratype.h"

struct EspeciesYTipos {
    u16 especie;
    u8 tipos[2]; // Cambia a 3 si permites más de un tipo
};

u8 GetTerastallizedNewType(void) {
	static const u8 tiposDisponibles[] = {TYPE_NORMAL, TYPE_FIGHTING, TYPE_FLYING, TYPE_POISON, TYPE_GROUND, TYPE_ROCK, TYPE_BUG, TYPE_GHOST, TYPE_STEEL, TYPE_FIRE, TYPE_WATER, TYPE_GRASS, TYPE_ELECTRIC, TYPE_PSYCHIC, TYPE_ICE, TYPE_DRAGON, TYPE_DARK, TYPE_FAIRY, TYPE_STELLAR};
}

static const struct SpeciesYTypes speciesYTypes[] = {
    {SPECIES_CHARIZARD, {TYPE_FIRE, TYPE_DRAGON}},
    {SPECIES_BLASTOISE, {TYPE_WATER}},
    // Agrega más especies y sus tipos según sea necesario
};

u8 GetTerastallizedNewType(u16 specie, u8 moveType) {
    // Buscar la especie en la lista y verificar si el tipo del ataque coincide con alguno de los tipos de la especie
    for (u8 i = 0; i < ARRAY_COUNT(speciesYTypes); ++i) {
        if (speciesYTypes[i].specie == specie) {
            if (speciesYTypes[i].types[0] == moveType || speciesYTypes[i].types[1] == moveType) {
                // Si el tipo del ataque coincide con uno de los tipos de la especie, devolver ese tipo
                return moveType;
            } else {
                // Si no coincide, devolver el primer tipo de la especie
                return speciesYTypes[i].types[0];
            }
        }
    }

    // Si no se encuentra la especie, devolver un tipo predeterminado (Tipo Normal, por ejemplo)
    return TYPE_NORMAL;
}